
enum ElemStatus {minimal=-5000, maximal};
enum Action {sum=-6000, prod};
enum ConvertType{row, column};
class Matrix
{
	private:
		//  
		unsigned xsize, ysize;
		//       
		double *Array;
      //  
      int temporary;
	public:
		//   
		unsigned getxsize(void) {return xsize;}
		unsigned getysize(void) {return ysize;}

		// ,    v
		Matrix(unsigned y = 1, unsigned x = 1, double v = 0);
		//  
		Matrix(Matrix &);
      //  " " xsize=ysize=1
		Matrix(double v);
		// ,  "!"   
		~Matrix(){delete []Array;} // cout << "!";}
		// "" 
		void show(void);
      //    
      double & operator()(unsigned n) const;

		// 1
      //  
      double & operator()(unsigned y, unsigned x) const;
		// 2
      //  
		Matrix & operator=(Matrix &M);
		//  
		Matrix & operator=(double v);
      //  
      Matrix & operator=(double v[]);
		// 3
      //  
		Matrix & operator+(const Matrix& M) const;
		Matrix & operator-(const Matrix& M) const;
		Matrix & operator+(double v) const;
		Matrix & operator-(double v) const;
		// 4
      //  
      friend Matrix & operator+(double v, const Matrix& M);
		friend Matrix & operator-(double v, const Matrix& M);
		// 5
      //    
      Matrix & Matrix::operator*(const Matrix& M) const;
		// 6
      //    
      Matrix & Matrix::operator*(double v) const;
      //    
      friend Matrix & operator*(double v, const Matrix& M);
      // 7
      //  
		Matrix & operator==(const Matrix& M) const;
		Matrix & operator>(const Matrix& M) const;
		Matrix & operator<(const Matrix& M) const;
      // 8
      //    
      Matrix & operator==(double v) const;
		Matrix & operator>(double v) const;
		Matrix & operator<(double v) const;
		// 9
      //    
      friend Matrix & operator==(double v, const Matrix& M);
      friend Matrix & operator>(double v, const Matrix& M);
      friend Matrix & operator<(double v, const Matrix& M);
		// 10
      //   
      Matrix & operator!() const;
		Matrix & operator-() const;
		// 11
      //   
      friend ostream & operator << (ostream & out, const Matrix & M);
      // 12
      //   
      friend istream & operator >> (istream & in, const Matrix & M);
      // 13
      //  
      Matrix & operator~() const;
      // 14
      //   
		Matrix & operator % (Matrix &M) const;
      // 15
      //   
		Matrix & Matrix::operator || (Matrix &M) const;
		// 16
      //  , 
		double & operator [](ElemStatus es)  const;
  		// 17
      //  , 
		double operator [](Action act)  const;
      // 18
      //   , 
  		Matrix & operator [](ConvertType ct)  const;
      // 19
      //     
		double&  operator [](double v)  const;
		//  20
      //   
      Matrix&  operator ()(unsigned y1, unsigned y2,
                           unsigned x1, unsigned x2)  const;
      //  :  
      friend double det(Matrix& M);
      friend Matrix& reverse(Matrix& M);
      friend Matrix & solut(Matrix& A, Matrix& B);
};

Matrix::Matrix(unsigned y, unsigned x, double v)
{
	unsigned asize = x*y;
	Array = new double[asize];
	xsize = x;
	ysize = y;
   temporary = 0;
  	for(int i = 0; i<asize; i++) Array[i] = v;
}

Matrix::Matrix(Matrix & M)
{
	xsize = M.xsize;
	ysize = M.ysize;
	unsigned asize = xsize*ysize;
	Array = new double[asize];
  	for(int i = 0; i<asize; i++) Array[i] = M.Array[i];
   temporary = 0;
  	if (M.temporary) delete &M;
}

Matrix::Matrix(double v)
{
	xsize = ysize = 1;
   Array = new double;
  	*Array = v;
   temporary = 0;
}

void Matrix::show(void)
{
	cout << '\n';
	for (int i = 0; i<ysize; i++)
   {
   		for (int j = 0; j<xsize; j++)
            	cout << Array[i*xsize+j]<< '\t';
   		cout << '\n';
   }
	if (temporary) delete this;
}
double & Matrix::operator()(unsigned n) const
{
	if (n > xsize*ysize)
   {
	   cerr << "Index exceeds matrix dimensions!";
	   exit(1);
   }
	if (temporary)
   {
	   cerr << "Operation is not allowed!";
	   exit(1);
   }
	return Array[n-1];
}

