#include <iostream.h>
#include <iostream.h>
// BinSTree    TreeNode
template <class T>
class BinSTree;

//   
template <class T>
class TreeNode
{
   friend class BinSTree<T>;
   friend  void DelDubNodes(TreeNode<T> *t);
   friend void Thread(TreeNode<T> *t);
   private:
   	  TreeNode<T> *left;
        TreeNode<T> *right;
   public:
   	T data;
      TreeNode(const T& item, TreeNode<T> *lptr = NULL,
                              TreeNode<T> *rptr = NULL):
      data(item), left(lptr), right(rptr) {}
      TreeNode<T> *Left(void) const {return left;}
      TreeNode<T> *Right(void) const {return right;}
};
template <class T>
void Inorder(TreeNode<T> *t, void (*visit)(T &item))
{
  //      (t=NULL)
  if (t)
  {
	Inorder(t->Left(), visit); //   
	(*visit)(t->data); //  
	Inorder(t->Right(), visit); //   
  }
}
template <class T>
TreeNode<T> * CopyTree(TreeNode<T> *t)
{
   if(!t) return NULL;
   TreeNode<T> * newlptr=NULL, * newrptr = NULL, * newnode;
   if (t->Left()) newlptr = CopyTree(t->Left());
   if (t->Right()) newrptr = CopyTree(t->Right());
   newnode = new TreeNode<T>(t->data, newlptr, newrptr);
   if (!newnode)
   {
		cout << "Memory allocation error";
		exit(1);
   }
   return newnode;
}

template <class T>
void DeleteTree(TreeNode<T> * t)
{
   if(t)
   {
	DeleteTree(t->Left());
	DeleteTree(t->Right());
   	delete t;
   }
}

template <class T>
void PrintTree(TreeNode<T> *t)
{
  //      (t=NULL)
  if (t)
  {
      cout << "   ";
   	if (t->Left()) cout << t->Left()->data; else cout<< "no";
      cout << ' ' << t->data << ' ';
   	if (t->Right()) cout << t->Right()->data; else cout<< " no";
     	PrintTree(t->Left()); //   
      PrintTree(t->Right()); //   
  }
}


